/**
 * @license Copyright (c) 2003-2013, CKSource - Frederico Knabben. All rights reserved.
 * For licensing, see LICENSE.html or http://ckeditor.com/license
 */

CKEDITOR.editorConfig = function( config ) {
	// Define changes to default configuration here. For example:
	// config.language = 'fr';
	// config.uiColor = '#AADC6E';
	
	config.toolbar = [
		{ name: 'clipboard', groups: [ 'clipboard', 'undo' ], items: [ 'Cut', 'Copy', 'Paste', 'PasteText', 'PasteFromWord', '-', 'Undo', 'Redo' ] },
		
		{ name: 'insert', items: [ 'Image', 'Table', 'HorizontalRule', 'SpecialChar', 'PageBreak' ] },
		{ name: 'blocks', groups: [ 'blocks' ], items: [ 'Blockquote', 'CreateDiv' ] },
		{ name: 'tools', items: [ 'ShowBlocks', 'Maximize' ] },
		'/',
		{ name: 'basicstyles', groups: [ 'basicstyles', 'cleanup' ], items: [ 'Bold', 'Italic', 'Underline', 'Strike', 'Subscript', 'Superscript', '-', 'RemoveFormat' ] },
		{ name: 'list', groups: [ 'list' ], items: [ 'NumberedList', 'BulletedList' ] },
		{ name: 'indent', groups: [ 'indent' ], items: [ 'Outdent', 'Indent' ] },
		{ name: 'align', groups: [ 'align' ], items: [ 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock' ] },
		{ name: 'links', items: [ 'Link', 'Unlink' ] },
		'/',
		{ name: 'styles', items: [ 'Styles', 'Format', 'Font', 'FontSize' ] },
		{ name: 'colors', items: [ 'TextColor', 'BGColor' ] },
		
		{ name: 'others', items: [ '-' ] },
		{ name: 'document', groups: [ 'mode' ], items: [ 'Source' ] }
	];
	
	/*
	config.toolbarGroups = [
		{ name: 'clipboard',   groups: [ 'clipboard', 'undo' ] },
		//{ name: 'editing',     groups: [ 'find', 'selection' ] }, //'spellchecker'
		{ name: 'links' },
		{ name: 'insert' },
		//{ name: 'forms' },
		{ name: 'tools' },
		{ name: 'others' },
		'/',
		{ name: 'basicstyles', groups: [ 'basicstyles', 'cleanup' ] },
		{ name: 'paragraph',   groups: [ 'list', 'indent', 'align', 'blocks', 'bidi' ] }, //  'blocks', 'bidi'
		'/',
		{ name: 'styles' },
		{ name: 'colors' },
		{ name: 'document',	   groups: [ 'mode', 'document', 'doctools' ] }
		 // { name: 'about' }
	];
	*/
	
	// Remove some buttons, provided by the standard plugins, which we don't
	// need to have in the Standard(s) toolbar.
	config.removeButtons = 'Underline,Subscript,Superscript';

	// Se the most common block elements.
	config.format_tags = 'p;h1;h2;h3;pre';

	// Make dialogs simpler.
	config.removeDialogTabs = ''; //image:advanced;link:advanced
	
	// Turn off filtering of extra CSS/JS/IDs etc... (if you only need specific items to be not filtered, use "config.extraAllowedContent = 'p(*){*}[*]';")
	config.allowedContent = true;
	
	// stops addition of line breaks on some tag endings and indenting paragraphs, tables and lists
	config.FormatOutput = false;
};
