<?php
/*
 * This file is part of a larger software package. Please read the License file 
 * in the root of this installation for terms of usage and distribution.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * 
 * CORE: manage/tables/website_user_types.php - version 1.0
*/

$nAdminOnlyPg = 1;

// Secure and connect
require("../../inc/dbconnect.php");
require("../inc/secure_page.php");

// bring in other required files
require("../inc/plugins.php");
require("../inc/pluginutil.php");
require("../inc/pageutil.php");

// Get plugin inclusion points for list, and insert them in header
$nPluginListInclARRAY = nGetListPluginInclusions("WebsiteUserTypes");

// Setup header
$nColumnARRAY = array();
//$nColumnARRAY["#Checkbox#"] = array("","","","vertical-align:middle;","{ \"sWidth\":\"31\", \"bSortable\":false }");
$nColumnARRAY["Name"] = array("","","","","");
$nColumnARRAY["Users"] = array("","","","","");
$nColumnARRAY["Active"] = array("","","","text-align:center;","");

// Insert plugin inclusion points for list in header
$nColumnARRAY = nInsertPluginHdrIncl($nPluginListInclARRAY,$nColumnARRAY);
$nHeaderDataTableJS = nBuildHeaderDataTableJS($nColumnARRAY);
?>
<script>
	$(function() {
	    // Initialize tables (if more than one per page, give it a second class for customization)
	    $('.dataTable').dataTable({
	        "sPaginationType": "full_numbers",
			"fnInfoCallback": function(oSettings){
	  			updateStyles();
			},
	        "bJQueryUI": true,
			"bStateSave": true,
			"aaSorting": [[ 1, "desc" ]],
			"aoColumns": [
				<?php echo $nHeaderDataTableJS;?>
			],
			"iDisplayLength": 20,
			"aLengthMenu": [[20, 50, 100, 200, -1], [20, 50, 100, 200, "All"]],
			"fnDrawCallback":function(){
				// Hide toolbar if showing less records than page-able
				if(this.fnSettings().fnRecordsTotal() <= this.fnSettings()._iDisplayLength){
					$('.dataTables_wrapper div.fg-toolbar').hide();
					$('.dataTables_wrapper').addClass("topBorder bottomBorder");
				} else {
					$('.dataTables_wrapper div.fg-toolbar').show();
				}
			}
	    });
	});
</script>

<form action="javascript:;" method="post" name="nListForm" id="nListForm" style="margin:0px;">
	<?php echo nGetWebsiteUserTypes()?>
</form>

<?php
function nGetWebsiteUserAmount($nID){
	global $DBName, $Link;
	$Query = "SELECT nID FROM nWebsiteUser WHERE nWebsiteUserTypeID=$nID";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	$nCurrentRecord = 0;
	while ($Row = mysql_fetch_array($Result)) {
		$nCurrentRecord++;
	}
	return $nCurrentRecord;
}
function nGetWebsiteUserTypes(){
	global $DBName,$Link,$nParam,$nPluginListInclARRAY,$nColumnARRAY;
	
	$Query = "SELECT * FROM nWebsiteUserType ORDER BY nNameType";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link); $nNumRec = mysql_num_rows($Result);
	
	$nTable = "";
	$nCurrentRecord = 1;
	
	if($nNumRec){
		// insert header and main listing table
		$nHeaderCode = nBuildHeaderHTML($nColumnARRAY);
		$nTable.="<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"dataTable\">";
		$nTable.="<thead><tr class=\"listHdr\">$nHeaderCode</tr></thead>";
		
		while($Row = mysql_fetch_array($Result)){
			// Get data
			$nID = $Row["nID"];
			$nWebsiteUserType = $Row["nNameType"];
			$nActive = $Row["nActive"];
			
			// Format data
			$nWebsiteUserAmount = nGetWebsiteUserAmount($nID);
			if($nWebsiteUserAmount){ $nWebsiteUserAmount = "<a href=\"website_users.php?nWebsiteUserType=$nID\">$nWebsiteUserAmount</a>"; }
			if($nActive) {
				$nActiveCode="<img src=\"assets/images/icons/tick.png\" alt=\"Active\" title=\"Active\" width=\"16\" height=\"16\" border=\"0\" hspace=\"30\">";
			} else { $nActiveCode="&nbsp;"; }
			
			// Setup row (data, width, align, class, style)
			$nColumnARRAY = array();
			//$nColumnARRAY["#Checkbox#"] = array("<input type=\"checkbox\" name=\"item_$nCurrentRecord\" value=\"$nID\" onClick=\"updateItemText();\">","","","","");
			$nColumnARRAY["Name"] = array("<a href=\"dialog/website_user_type_modify.php?wut=$nID\" title=\"Edit Website User Type: ".addslashes(stripslashes($nWebsiteUserType))."\" class=\"modal\">$nWebsiteUserType</a>","","","","");
			$nColumnARRAY["Users"] = array("$nWebsiteUserAmount","","","","");
			$nColumnARRAY["Active"] = array("$nActiveCode","","","","text-align:center;");
			
			// Get plugin inclusion points for list, and insert them in row
			$nColumnARRAY = nInsertPluginRowIncl($nPluginListInclARRAY,$nColumnARRAY,$nID);
			$nRowCode = nBuildRowHTML($nColumnARRAY);
			
			// Insert row
			$nTable.="<tr id=\"row$nID\">$nRowCode</tr>";
			$nCurrentRecord++;
		}
		// Insert footer
		$nTable.= "</table>".nGetActionFooter()."<BR><BR>";
	} else {
		$nTable.= "<div style=\"text-align:center; padding:50px 0;\"><i>There are currently no user types to display.</i></div>";
	}
	return $nTable;
}
function nGetActionFooter(){
	$nFooter = "<div style=\"padding:8px;\">\n";
	$nFooter.= "	<strong>With <strong id=\"itemAmount\">0</strong> items selected:</strong> \n";
	$nFooter.= "	<input type=\"button\" name=\"nRemove\" id=\"nRemove\" value=\" Remove \" onClick=\"editList('custtype','remove');\" disabled> \n";
	$nFooter.= "	<input type=\"button\" name=\"nEdit\" id=\"nEdit\" value=\" Edit \" onClick=\"editList('custtype','edit');\" disabled>\n";
	$nFooter.= "</div>\n";
	return $nFooter;
}
function nGetWebsiteUserTypeName($nID) {
	global $DBName, $Link;
	$Query = "SELECT nNameType FROM nWebsiteUserType WHERE nID=$nID LIMIT 1";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nWebsiteUserType=$Row["nNameType"];
	}
	return $nWebsiteUserTypeName;
}
function nGetCustOrderCount($nCustID){
	global $DBName,$Link;
	$nCount = 0;
	$Query = "SELECT nID,nOrderNum FROM nOrderInfo WHERE nCustID=$nCustID";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	while ($Row = mysql_fetch_array($Result)){
		$nCount++;
	}
	return $nCount;
}
function formatPhone($nPhone){
	if($nPhone){ $nPhone = preg_replace("/\D/","",$nPhone); }
	// if 7 chars, format like this: ###-####
	if(strlen($nPhone)==7){ return substr($nPhone,0,3)."-".substr($nPhone,3,4); }
	// if 10 chars, format like this: (###)###-####
	if(strlen($nPhone)==10){ return "(".substr($nPhone,0,3).") ".substr($nPhone,3,3)."-".substr($nPhone,6,4); }
	// if 11 chars, format like this: #(###)###-####
	if(strlen($nPhone)==11){ return substr($nPhone,0,1)." (".substr($nPhone,1,3).") ".substr($nPhone,4,3)."-".substr($nPhone,7,4); }
	return $nPhone;
}
?>
<?php
// disconnect from mysql
mysql_close($Link);
?>